<?php
/**
 * Controller base class
 * @package base
 * @since 1.0
 * @author JJB <splitedragon@hotmail.com>
 * @copyright Copyright (c) 2019, EVENING
 */
class Cache
{
	protected $_original;
	protected $_path;
	protected $_name;
	
	public function __construct($path)
	{
        $this->setOriginal($path);
        $this->setName();
        $this->setPath();
	}

	public function setOriginal($path)
    {
        $this->_original = $path;
    }
    public function getOriginal()
    {
        return $this->_original;
    }

	public function setName()
    {
        $this->_name = md5($this->_original);
    }
    public function getName()
    {
        return $this->_name;
    }

    public function setPath()
    {
        $this->_path = gURL('cache').DS.$this->getName();
    }
    public function getPath()
    {
        return $this->_path;
    }

    public function write($contents)
    {
        /*$handle = fopen($this->_path, 'w');
        fwrite($handle, $contents);
        fclose($handle);*/
        @file_put_contents($this->_path, $contents);
    }

    public function check()
    {
        if(file_exists($this->_path)) return true;
        return false;
    }

    public function get()
    {
        if($this->check()) {
            /*$handle = fopen($this->_path, "rb");
            $contents = fread($handle, filesize($this->_path));
            fclose($handle);*/
            $contents = @file_get_contents($this->_path);
            return $contents;
        }
        return '';
    }

    public function delete()
    {
        if($this->check()) {
            @unlink($this->_path);
        }
    }
}