<?php
/**
 * Super global define code.
 * In this code defined variable, method is global.
 * So u take care to define the method or variable to avoid define as duplicate name in other code.
 * Global methods naming must use prefix - 'g' as first character.
 * The defined methods can be accessed directly calling them.
 */


define('NAMESPACE_BASEPATH', 'vendors');



function gNamespaceMap()
{
    /**
     * Example see /utils/Mailer.php using /vendors/PHPMailer
     * PHPMailer use namespace like:
     * use PHPMailer\PHPMailer\PHPMailer = \PHPMailer\PHPMailer\PHPMailer;
     * The namespace are divided path and class file
     * At Evening.php defines namespace is PHPMailer\PHPMailer and file name is PHPMailer.php
     * Actually PHPMailer.php file is located at NAMESPACE_BASEPATH.DS.'PHPMailer'.DS.'src'
     * So you need to config the actual file path for including.
     */
    return array(
        'PHPMailer\\PHPMailer' => NAMESPACE_BASEPATH.DS.'PHPMailer'.DS.'src',
        'Gumlet' => NAMESPACE_BASEPATH.DS.'ImageMaster3'.DS.'lib',
    );
}