<?php
/**
 * Super global define code.
 * In this code defined variable, method is global.
 * So u take care to define the method or variable to avoid define as duplicate name in other code.
 * Global methods naming must use prefix - 'g' as first character.
 * The defined methods can be accessed directly calling them.
 */


/*
 * May be used as home page i.e. $g_default_router is used to define the default first page.
 */
function gDefaultRoute()
{
    return array(
        'controller'=>"home",
        'action'=>"index",
        'argument'=>NULL
    );
}

/**
 * Customize routing.
 * Each item's type must be following:
 * 'admin/login'=>array('account', 'login', '/admin')
 *
 * 'path' is value of where is located controller file.
 * If path is undefined, default is empty string as ''.
 *
 * The controller is controller name, router will find at 'controllers/[path]/[controller]Controller.php'
 *
 * If action is undefined, default action is action value of gDefaultRoute.
 *
 * The type of each key in array is formatted like 'controller/action' or 'controller'.
 *
 * Forward item has priority over backward item.
 *
 * !Important
 * This ignore gRoutes rule.
 * @return array
 */
function gRoutes()
{
    return array(
        // Request method is GET
        'GET' => array(
            '/blog/client'=> array('BlogClient'),
        ),
        // Request method is POST
        'POST' => array(
            '/blog/client'=> array('BlogClient'),
        ),
        // Request method is PUT
        'PUT' => array(

        ),
        // Request method is DELETE
        'DELETE' => array(

        ),
    );
}

/**
 * Define sub-application.
 * For example, if you want that backend application placed in 'controllers/admin' folder, then you can define sub-app using gModules().
 * If you undefined as 'admin' and request like 'http://localhost/admin/a', will be find controllers/AdminController and action a().
 * but defined 'admin' in gModules(), will be find controllers/admin/AController and action index()
 * @return array
 */
function gModules()
{
    // Like as '' | 'admin' | 'admin/contact'
    return array(
        'admin/super',
        '/admin/', // Equal admin, admin/, admin/, /admin, /admin/
    );
}